#include<bits/stdc++.h>
using namespace std;
int n,c,q,x,y,brnula,brjedinica,cpybrnula,cpybrjedinica;
int razlika,ukupna_suma,dobra_pozicija;
string s;
int main()
{
    scanf("%d %d %d",&n,&c,&q);
    cin>>s;
    for(int i=0;i<s.size();i++)
    {
        if(s[i]=='0')
        {
            brnula++;
        }
        else
        {
            brjedinica++;
        }
    }
    for(int i=1;i<=q;i++)
    {
        scanf("%d %d",&x,&y);
        razlika=0;
        cpybrjedinica=brjedinica;
        cpybrnula=brnula;
        if(x==y)
        {
            if(s[x-1]=='1')
            {
                cpybrjedinica--;
                cpybrnula++;
            }
            else
            {
                cpybrjedinica++;
                cpybrnula--;
            }
        }
        for(int j=x-1;j<=y-1;j++)
        {
            if(s[j]=='0')
            {
                s[j]='1';
                cpybrjedinica++;
                cpybrnula--;
            }
            else
            {
                s[j]='0';
                cpybrnula++;
                cpybrjedinica--;
            }
        }
        if(c==n)
        {
            printf("%d\n",cpybrjedinica);
            continue;
        }
        else
        {
            printf("%d\n",1);
        }
    }
    return 0;
}